/* Endian-independent IEEE floating point layout */

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */

typedef union {
	FLOAT           fsu;
	struct {
		unsigned        f1:23;
		unsigned        e:8;
		unsigned        s:1;
		unsigned        f2:32;
		unsigned        f3:32;
		unsigned        f4:8;
		unsigned        f5:8;
		unsigned        f6:8;
		unsigned        f7:8;
	}               rs;
	struct {
		unsigned        s:1;
		unsigned        e:8;
		unsigned        f1:23;
		unsigned        f2:32;
		unsigned        f3:32;
		unsigned        f4:8;
		unsigned        f5:8;
		unsigned        f6:8;
		unsigned        f7:8;
	}               ls;
	struct {
		unsigned        f3:BIGBASE_BITS;
		unsigned        f2:32 - BIGBASE_BITS;	/* pad out to 4 bytes */
		unsigned        f1:20;
		unsigned        e:11;
		unsigned        s:1;
		unsigned        f4:16;
		unsigned        f5:16;
		unsigned        f6:16;
		unsigned        f7:16;
	}               rd;
	struct {
		unsigned        s:1;
		unsigned        e:11;
		unsigned        f1:20;
		unsigned        f2:32 - BIGBASE_BITS;	/* pad out to 4 bytes */
		unsigned        f3:BIGBASE_BITS;
		unsigned        f7:16;
		unsigned        f6:16;
		unsigned        f5:16;
		unsigned        f4:16;
	}               ld;
	struct {
		unsigned        s:1;
		unsigned        e:15;
		unsigned        us:16;
		unsigned        f1:64 - 2 * BIGBASE_BITS;
		unsigned        f2:2 * BIGBASE_BITS - 32;
		unsigned        f3:32 - BIGBASE_BITS;
		unsigned        f4:BIGBASE_BITS;
		unsigned        f5:16;
		unsigned        f6:8;
		unsigned        f7:8;
	}               lx;
	struct {
		unsigned        f4:BIGBASE_BITS;
		unsigned        f3:32 - BIGBASE_BITS;	/* pad out to 4 bytes */
		unsigned        f2:2 * BIGBASE_BITS - 32;
		unsigned        f1:64 - 2 * BIGBASE_BITS;
		unsigned        e:15;
		unsigned        s:1;
		unsigned        us:16;
		unsigned        f5:16;
		unsigned        f6:8;
		unsigned        f7:8;
	}               rx;
	struct {
		unsigned        s:1;
		unsigned        e:15;
		unsigned        f1:16;
		unsigned        f2:96 - 3 * BIGBASE_BITS;
		unsigned        f3:3 * BIGBASE_BITS - 64;
		unsigned        f4:64 - 2 * BIGBASE_BITS;
		unsigned        f5:2 * BIGBASE_BITS - 32;
		unsigned        f6:32 - BIGBASE_BITS;
		unsigned        f7:BIGBASE_BITS;
	}               lq;
	struct {
		unsigned        f7:BIGBASE_BITS;
		unsigned        f6:32 - BIGBASE_BITS;
		unsigned        f5:2 * BIGBASE_BITS - 32;
		unsigned        f4:64 - 2 * BIGBASE_BITS;
		unsigned        f3:3 * BIGBASE_BITS - 64;
		unsigned        f2:96 - 3 * BIGBASE_BITS;
		unsigned        f1:16;
		unsigned        e:15;
		unsigned        s:1;
	}               rq;
}               ieeeuniontype;
