/* Routines for accessing David Gay's conversion routines */

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#define NO_CONVERSION_ROUTINES
#include "precision/sun4.1-dp.c"

#define IEEE_MC68k
#define Check_FLT_ROUNDS
#include "precision/dgay-dtoa.c"

void
testbd(x, s, n, t, e)
	FLOAT          *x;
	decimalstring   s;
	unsigned long  *n;
	enum testtype  *t;
	int            *e;
{
	char *result, *rp, *sp;
	int decimal_point, sign, mode;

	mode = (*t == btof) ? 3 : 2;

	result = dtoa( *x, mode, (int) *n, &decimal_point, &sign, (char **) 0 );

	if ( *t == btof ) {
		rp = result;
		sp = s;

		if ( sign )
			*sp++ = '-';

		while ( decimal_point > 0 ) {
			if ( *rp )
				*sp++ = *rp++;
			else
				*sp++ = '0';

			--decimal_point;
		}

		*sp++ = '.';

		while ( decimal_point < 0 ) {
			*sp++ = '0';
			++decimal_point;
		}

		while ( *rp )
			*sp++ = *rp++;

		*sp = '\0';

	} else {
		sprintf( s, "%c%c.%se%d", (sign ? '-' : '+'),
			result[0], &result[1], decimal_point - 1 );
	}

	*e = 0;
}

void
testdb(s, x, e)
	char           *s;
	FLOAT          *x;
	int            *e;
{
	*x = strtod( s, (char **) 0 );
	*e = 0;
}
