/* Routines for dealing with IEEE exceptions for Ultrix V2.1 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <mips/fpu.h>


void clear_exceptions()
	{ /* Clear all exception flags. */
	union fpc_csr csr;

	csr.fc_word = get_fpc_csr();

	csr.fc_struct.se_inexact = 0;
	csr.fc_struct.se_underflow = 0;
	csr.fc_struct.se_overflow = 0;
	csr.fc_struct.se_divide0 = 0;
	csr.fc_struct.se_invalid = 0;

	(void) set_fpc_csr( (int) csr.fc_word );
	}

int get_exceptions()
	{
	/* Return the present setting of the exception flags. */

	union fpc_csr csr;
	int result;

	result = 0;

	csr.fc_word = get_fpc_csr();

	if (csr.fc_struct.se_inexact)
		result |= (1 << exception_inexact);

	if (csr.fc_struct.se_underflow)
		result |= (1 << exception_underflow);

	if (csr.fc_struct.se_overflow)
		result |= (1 << exception_overflow);

	if (csr.fc_struct.se_invalid)
		result |= (1 << exception_invalid);

	return result;
	}
