/* Routines for dealing with IEEE exceptions for AIX 3.1 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <float.h>
#include <fpxcp.h>


void clear_exceptions()
	{
	/* Clear all exception flags. */
	fp_clr_flag( FP_INVALID | FP_OVERFLOW | FP_UNDERFLOW |
		     FP_DIV_BY_ZERO | FP_INEXACT );
	}

int get_exceptions()
	{
	/* Return the present setting of the exception flags. */

	int result;
	fpflag_t excep;

	result = 0;

	excep = fp_read_flag();

	if ((excep & FP_INEXACT) != 0)
		result |= (1 << exception_inexact);

	if ((excep & FP_UNDERFLOW) != 0)
		result |= (1 << exception_underflow);

	if ((excep & FP_OVERFLOW) != 0)
		result |= (1 << exception_overflow);

	if ((excep & FP_INVALID) != 0)
		result |= (1 << exception_invalid);

	return result;
	}
