/* Routines for manipulating IEEE rounding modes for AIX 3.1 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <float.h>


void set_test_rounding( rounding_mode )
	enum roundingtype	rounding_mode;
{
	/* Set the rounding mode to be used during the test conversions. */

	switch (rounding_mode) {
	case round_unbiased:
		(void) fp_swap_rnd(FP_RND_RN);
		break;
	case round_up:
		(void) fp_swap_rnd(FP_RND_RP);
		break;
	case round_down:
		(void) fp_swap_rnd(FP_RND_RM);
		break;
	case round_in:
		(void) fp_swap_rnd(FP_RND_RZ);
		break;


	/* The following don't exist under RS6000; fake them ...  */
	case round_out:
	case round_biased:
	case round_one:
	case round_two:
		(void) fp_swap_rnd(FP_RND_RN);
		break;

	default:
		fatal("bad rounding type in set_test_rounding()");
	}
}
