/* Routines for manipulating IEEE rounding modes for IRIX 3.3.2 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <sys/fpu.h>


void set_test_rounding( rounding_mode )
	enum roundingtype	rounding_mode;
{
	/* Set the rounding mode to be used during the test conversions. */

	switch (rounding_mode) {
	case round_unbiased:
		(void) swapRM(ROUND_TO_NEAREST);
		break;
	case round_up:
		(void) swapRM(ROUND_TO_PLUS_INFINITY);
		break;
	case round_down:
		(void) swapRM(ROUND_TO_MINUS_INFINITY);
		break;
	case round_in:
		(void) swapRM(ROUND_TO_ZERO);
		break;


	case round_out:
	case round_biased:
	case round_one:
	case round_two:
		(void) swapRM(ROUND_TO_NEAREST);
		break;

	default:
		fatal("bad rounding type in set_test_rounding()");
	}
}
