/* Routines for dealing with IEEE exceptions for SunOS 4.1 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <floatingpoint.h>


int ieee_flags( /* action, mode, in, out */ );


void clear_exceptions()
	{
	/* Clear all exception flags. */
	(void) ieee_flags("clear", "exception", "all", (char **) 0);
	}

int get_exceptions()
	{
	/* Return the present setting of the exception flags. */

	char	ieee_result_buf[40];
	char	*ieee_result_ptr = ieee_result_buf;
	int	excep;

	/* Even though it looks like we're just asking for "inexact" in
	 * the following call, the return status of ieee_flags() will be
	 * a mask of all the set exception flags.
	 */
	excep = ieee_flags("get", "exception", "inexact", &ieee_result_ptr);

	return translate_SUNOS_IEEE_exceptions( excep );
	}


int translate_SUNOS_IEEE_exceptions( excep )
int excep;
	{
	/* Convert SUNOS-specific exception flags to those used by testbase. */

	int	result = 0;

	if ((excep & (1 << fp_inexact)) != 0)
		result |= (1 << exception_inexact);

	if ((excep & (1 << fp_underflow)) != 0)
		result |= (1 << exception_underflow);

	if ((excep & (1 << fp_overflow)) != 0)
		result |= (1 << exception_overflow);

	if ((excep & (1 << fp_invalid)) != 0)
		result |= (1 << exception_invalid);

	return result;
	}
