#ifndef lint
c	static	char sccsid[] = "@(#)fbase.F 1.6 90/03/09 SMI";
#endif

/*
 * Copyright (c) 1990 by Sun Microsystems, Inc.
 */

c	Sample base test conversion interface for Fortran.
c	This program is adapted to SunOS calling conventions between
c	C and Fortran - other systems may vary.

#define FDEFS	/* get only FORTRAN definitions from header file */
#include "testbase.h"

#define Inexact 1
#define Underflow 2
#define Overflow 4
#define Invalid 8
#ifdef i386
#define INEXACT 32
#define UNDERFLOW 16
#define OVERFLOW 8
#define INVALID 1
#else
#define INEXACT 1
#define UNDERFLOW 4
#define OVERFLOW 8
#define INVALID 16
#endif

	subroutine testbd(b,d,n,t,e)
	FBINARY b
	FDECIMAL d
	integer n
	integer t
	integer e
	
	character*40 fmt
	character*40 prefmt
	integer i,j,trial
	integer ie

	/* Sun-specific */
	integer ieee_flags
	character*20 out

	trial = 0
c		set up the template for the format to be tested
	if (t .eq. BTOE) then
		prefmt = "('(e',i4,'.',i4,'E4,A1)')"
	else if (t .eq. BTOF) then
		prefmt = "('(f',i4,'.',i4,',A1)')"
	else if (t .eq. BTOG) then
		prefmt = "('(g',i4,'.',i4,'E4,A1)')"
	else
		prefmt = '(''junk'')'
	endif
c		set up the format to be tested by inserting precision and field width
	write(fmt,prefmt) n+9, n
 1	continue
c		do the conversion to be tested and append a null

/* For systems without access to exception flags:
	write(d, fmt) b, char(0)
	ie=INEXACT
*/
	ie= ieee_flags("clear","exception","all",out)
	write(d, fmt) b, char(0)
	ie=ieee_flags("get","exception","inexact",out)

	e=0
	if(and(ie,INEXACT) .ne. 0) e = or(e, Inexact)
	if(and(ie,UNDERFLOW) .ne. 0) e = or(e, Underflow)
	if(and(ie,OVERFLOW) .ne. 0) e = or(e, Overflow)
	if(and(ie,INVALID) .ne. 0) e = or(e, Invalid)
c		if conversion failed due to field overflow, try again
	if (d(1:1) .eq. '*') then
		if (trial .eq. 0) then
			prefmt = "('(f',i4,'.',i4,',A1)')"
			write(fmt,prefmt) DECIMALSTRING_LENGTH-4-n, n
			trial = 1
			goto 1
		else if (trial .eq. 1) then
			prefmt = "('(e',i4,'.',i4,'E4,A1)')"
			write(fmt,prefmt) DECIMALSTRING_LENGTH-10-n, n
			trial = 2
			goto 1
		else
			d = "+NaN(field_overflow)"	
			if (b .lt. 0) d(1:1) = '-'
		endif
	endif
c		compress the leading blanks out of the decimal result
	do 2 i = 1, DECIMALSTRING_LENGTH-3
	if (d(i:i) .ne. ' ') goto 3
 2	continue
 3	continue
	if (i .gt. 1) then
		do 4 j = i,DECIMALSTRING_LENGTH
		d(j+1-i:j+1-i) = d(j:j)		
		if (d(j:j) .eq. char(0)) goto 5
 4		continue
 5		continue
	end if
	end

	subroutine testdb(d,b,e)
	FBINARY b
	FDECIMAL d
	integer e

	integer ie

	/* Sun-specific */
	integer ieee_flags
	character*20 out

/* For systems without access to exception flags
	read(d, *) b
	ie=INEXACT
*/

	ie = ieee_flags("clear","exception","all",out)
	read(d, *) b
	ie= ieee_flags("get","exception","inexact",out)

	e=0
	if(and(ie,INEXACT) .ne. 0) e = or(e, Inexact)
	if(and(ie,UNDERFLOW) .ne. 0) e = or(e, Underflow)
	if(and(ie,OVERFLOW) .ne. 0) e = or(e, Overflow)
	if(and(ie,INVALID) .ne. 0) e = or(e, Invalid)
	end	
