/* Routines for manipulating IEEE rounding modes for SunOS 4.1 */

#ifndef lint
static char     sccsid[] = "@(#)testbase.c 1.14 91/02/28 SMI";
#endif

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */


#include "testbase.h"
#include <floatingpoint.h>


int ieee_flags( /* action, mode, in, out */ );


void set_test_rounding( rounding_mode )
	enum roundingtype	rounding_mode;
{
	/* Set the rounding mode to be used during the test conversions. */
	char		*out;

	switch (rounding_mode) {
	case round_unbiased:
		(void) ieee_flags("set","direction","nearest",&out);
		break;
	case round_up:
		(void) ieee_flags("set","direction","positive",&out);
		break;
	case round_down:
		(void) ieee_flags("set","direction","negative",&out);
		break;
	case round_in:
		(void) ieee_flags("set","direction","tozero",&out);
		break;
	case round_out:
		(void) ieee_flags("set","direction","positive",&out);
		break;

	/*
	 * The following don't exist on Suns but we fake them to test
	 * the program's error handling.
	 */

	case round_biased:
		(void) ieee_flags("set","direction","nearest",&out);
		break;

	case round_one:
	case round_two:
		(void) ieee_flags("set","direction","nearest",&out);
		break;

	default:
		fatal("bad rounding type in set_test_rounding()");
	}
}
